#include <iostream>
using namespace std;
int main()
{
    long long X,Y,Q;
    cin>>X>>Y;	
    long long ludiNav[X][Y];

    for(int i=0;i<=X-1;i++)
    {
        for(int j=0;j<=Y-1;j++)
        {
            cin>>ludiNav[i][j];
        }
    }
    cin>>Q;
    int blokx,bloky;
    for(int k=0;k<Q;k++)
    {
		cin>>blokx>>bloky;
		long long konejner=ludiNav[blokx-1][bloky-1];
	ludiNav[blokx-1][bloky-1]=1000000000;

    int najmanjeNav[X][Y]; 

    najmanjeNav[0][0] = ludiNav[0][0];

    for(int j=1;j<=Y-1;j++)
        najmanjeNav[0][j] = najmanjeNav[0][j-1] + ludiNav[0][j];

    for(int i = 1;i<=X-1;i++)
        najmanjeNav[i][0] = najmanjeNav[i-1][0] + ludiNav[i][0];

    
    for(int i=1;i<=X-1;i++)
    {
        for(int j=1;j<=Y-1;j++)
        {
            najmanjeNav[i][j] = min(najmanjeNav[i-1][j],najmanjeNav[i][j-1]) + ludiNav[i][j];
        }
    }

    cout<<najmanjeNav[X-1][Y-1]<<endl;
    ludiNav[blokx-1][bloky-1]=konejner;
   }
}